//By Verite Rendition
//Sovereignty parser, takes raw ESI structure data and formats it for easier comparison. Also spits out a SQL statement
//Yes it's ugly, but it works
//Now for ESI2, 12/31/2022
#include <iostream>
#include <string>
#include <fstream>
#include "../nlohmann/json.hpp" //Using JSON for Modern C++ 3.1.2 (single includes version)

using namespace std;

using json = nlohmann::json;

int main()
{
	unsigned int SSID; //Solar System ID
	unsigned int ALID; //Alliance ID
	int sovlevel;
	double ADM;
	json jStruct; //Create json structure
	//char c;
	ifstream jsonFile;
	ofstream updateFile,updateFile2;

	updateFile.open("updateSov.sql");
	updateFile2.open("sov.txt");
	
	jsonFile.open("structures.json"); //Open CCP ESI Structures JSON file
	
	if (jsonFile.is_open())
	{
		cout << "Sov Sanitizer Working" << endl;
	}
	else
	{
		cout << "Not Working" << endl;
		return 0;
	}
	
	updateFile << "update mapsolarsystems set allianceID = 0;" << endl; //Zero out current alliance IDs since we'll repopulate from the structure listing (and we aren't told what sov null systems don't have an owner)

	jsonFile >> jStruct; //Read sov into json structure

	for (int i = 0; i < jStruct.size(); i++) //Loop through system list, parse out solar system sov info
	{
		//Structures are only allowed in sov null-sec. So this automatically excludes w-space (systems starting with 31), Abyssal space (starting with 32) & Empire systems (which can't have structures)
		ADM = 0;
		ALID = 0;

		SSID = jStruct[i]["solar_system_id"];
		
		if (jStruct[i]["structure_type_id"]==32458) //If the structure is an IHub, record the owner as the sov system holder
		{
			ALID = jStruct[i]["alliance_id"];
			updateFile << "update mapsolarsystems set allianceID = " << ALID << " where solarSystemID = " << SSID << ";" << endl; //Write out SQL line for sov holder
			updateFile2 << SSID << "," << ALID << endl; //Write out sov change finder line
		}

		if (!jStruct[i]["vulnerability_occupancy_level"].is_null()) //If the ADM level is present, record it (regardless of what type of structure it is)
		{
			ADM = jStruct[i]["vulnerability_occupancy_level"];
			updateFile << "update mapsolarsystems set ADM = " << ADM << " where solarSystemID = " << SSID << ";" << endl; //Write out SQL line for ADM level
		}
			
	}

	updateFile.close();
	updateFile2.close();
	return 0;
}	

